#include "config.h"
#include "rsyslog.h"
#include "srUtils.h"
#if !defined(_AIX)
#pragma GCC diagnostic ignored "-Wsign-compare"
#pragma GCC diagnostic ignored "-Wmissing-noreturn"
#endif

#line 10 "lexer.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 6
#define YY_FLEX_SUBMINOR_VERSION 0
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

extern yy_size_t yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    #define YY_LINENO_REWIND_TO(dst) \
            do {\
                const char *p;\
                for ( p = yy_cp-1; p >= (dst); --p)\
                    if ( *p == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
yy_size_t yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,yy_size_t len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap() (/*CONSTCOND*/1)
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#ifdef yytext_ptr
#undef yytext_ptr
#endif
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
#if defined(__GNUC__) && __GNUC__ >= 3
__attribute__((__noreturn__))
#endif
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 116
#define YY_END_OF_BUFFER 117
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[601] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    9,    9,    0,    0,  117,  115,  114,  114,
      115,  115,  115,   54,   87,  115,  115,  115,  115,   92,
      115,   92,   92,   92,   92,   92,   92,   92,   92,   92,
       92,   92,   92,   92,   92,   55,   56,   86,  114,   87,
      115,  115,  115,   92,   92,   92,   92,   92,   92,   92,
       92,   92,   92,   92,   92,   92,   92,   92,  107,  106,
      106,  107,  107,   93,   95,  107,   98,   94,   96,   97,
      104,  104,  104,   69,   69,   68,   67,   66,   52,   51,
       51,   52,   10,    9,    9,   10,   10,    4,    8,    7,

       50,   48,   48,   50,   50,   45,   22,   24,   50,   11,
       29,   20,   23,   19,   25,   21,   44,   44,   14,   35,
       18,   36,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   26,   27,    0,    0,  113,    0,    0,   91,   91,
       91,   89,  100,   92,    0,   92,   92,   92,   92,   92,
       92,   92,    1,   92,   92,   92,   92,   92,   92,   92,
       92,   92,   92,   92,   92,   92,    0,    0,    0,    0,
        0,    0,    0,    0,   91,    0,    0,    0,   92,   92,
       92,   92,   92,   92,   92,   92,   92,   92,    1,   92,
       92,   92,   92,   92,   92,   92,   92,   92,   92,   92,

       92,   92,    0,   99,    0,    0,  105,  101,   94,  104,
      104,  103,   70,   66,   53,    9,    0,    6,    0,    0,
        5,    0,   33,    0,   47,    0,   45,   45,   45,   45,
        0,   46,    0,  102,   42,    0,   44,   31,   34,   30,
       32,   49,   49,   49,   13,   38,   49,   15,   49,   49,
        0,  109,    0,  108,    0,    0,  111,    0,   91,   91,
       88,   88,   89,   90,   92,   92,   92,   92,   92,   92,
       92,   92,   92,   92,   92,   92,   92,   92,   92,   92,
       92,   61,   92,   92,   92,   92,   85,    0,  112,   91,
        0,    0,   85,   92,   92,   92,   92,   92,   92,   92,

       92,   92,   92,   92,   92,   92,   92,   92,   92,   92,
       61,   92,   92,   92,   92,    0,    0,    0,    0,    0,
        0,    0,    0,    0,   43,   16,   49,   17,   49,   49,
        0,  110,   91,   88,   88,   90,   92,   59,   92,   92,
       92,   58,   92,   92,   92,   92,   92,   92,   92,   92,
       92,   92,   92,   92,   57,   92,   92,   92,    0,    0,
        0,   92,   59,   92,   92,   58,   92,   92,   92,   92,
       92,   92,   92,   92,   92,   92,   92,   92,   57,   92,
       92,   92,    0,    0,    0,    0,    0,    0,    0,    0,
        0,   49,   49,   12,   92,   92,   92,   92,   92,   92,

       92,   92,   92,   92,   92,   92,   92,   92,   92,   62,
       92,   92,   92,   63,    0,    0,   92,   92,   92,   92,
       92,   92,   92,   92,   92,   92,   92,   92,   62,   92,
       92,   92,   63,    0,   49,   49,   92,   92,   92,   92,
       92,   92,   92,    0,   79,   92,   92,   92,   92,   92,
       92,   92,   92,   92,   92,    0,    0,   92,   92,   92,
       92,   92,   92,   92,   92,   92,   92,   92,   92,   92,
       92,   49,   49,    0,   83,   92,   92,   92,   92,    2,
        0,   74,   92,   92,    0,   80,    0,   73,   92,   92,
       92,   92,   92,   92,    0,   84,    0,   92,   92,    2,

       92,   92,   92,   92,   92,   49,   49,   92,   92,   64,
       92,   92,   92,   92,   92,   92,    0,   76,   92,   92,
       84,   92,   64,   92,   92,   92,   92,   37,   49,   92,
        0,   78,   92,   92,   92,   92,    0,   77,   92,    0,
       75,    0,   72,   92,   49,   49,   92,    0,   82,   92,
       92,   92,   92,   92,   39,   40,   92,   92,    0,   71,
       92,   92,   92,   49,   92,   92,   92,   92,   92,   41,
       60,    0,   81,   92,   92,   92,   92,   92,   92,   92,
       92,   92,   92,   92,   92,   92,   92,   92,   92,   92,
       92,   92,    3,   92,   92,   92,   92,   92,   65,    0

    } ;

static yyconst YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    8,    9,   10,   11,   12,
       13,   14,   15,   16,   17,   18,   19,   20,   21,   21,
       21,   21,   21,   21,   21,   22,   22,   23,   24,   25,
       26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
       36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
       46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
       56,   57,   58,   59,   60,    1,   61,   62,   63,   64,

       65,   66,   67,   68,   69,   39,   70,   71,   72,   73,
       74,   75,   76,   77,   78,   79,   80,   51,   81,   82,
       83,   84,   85,   59,   86,   87,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst YY_CHAR yy_meta[88] =
    {   0,
        1,    2,    3,    4,    5,    6,    1,    7,    1,    1,
        6,    1,    1,    8,    9,   10,   11,   12,   13,   14,
       14,   15,   16,   17,    1,   18,    1,   19,   20,   21,
       22,   23,   23,   23,   21,   24,   24,   24,   24,   24,
       24,   24,   25,   24,   24,   24,   25,   24,   25,   24,
       26,   24,   27,   24,   24,   20,    6,   20,    1,   28,
       21,   22,   23,   23,   23,   21,   24,   24,   24,   24,
       24,   24,   25,   24,   24,   24,   25,   24,   25,   24,
       24,   27,   24,   24,    1,    1,    1
    } ;

static yyconst flex_uint16_t yy_base[688] =
    {   0,
        0,   87,  174,    0,  259,  260,  262,  265,  257,  262,
      284,    0,  370,  385,  401,    0, 1179, 4164, 4164, 4164,
        0, 1173,    0, 4164, 4164, 1157,  257,    0, 1130,    0,
        0,  457,  460,  439,  453,  451,  455,  457,  453,  468,
      471,  481,  468,  471,  464, 4164, 4164,    0,  537,  359,
     1110,  561,  536,  577,  590,  637,  595,  601,  552,  630,
      633,  635,  656,  658,  678,  680,  704,  683, 4164, 4164,
     4164,  493, 1095, 4164, 4164, 1064, 4164,    0, 4164, 4164,
     1071, 1058, 1018,    0, 4164, 4164, 4164,  372, 4164, 4164,
     4164,    0, 4164,  620,  625,  502,  492, 4164, 4164, 4164,

     4164, 4164, 4164,  977,  507,  762, 4164, 4164,  524, 4164,
     4164, 4164, 4164, 4164, 4164,  978,  582,  612, 4164,  254,
      963,  954,  557,    0,  592,  599,  642,  646,  646,  646,
      477, 4164, 4164,  680,  934, 4164,  820,  759,    0,  783,
      381,    0, 4164,    0,  903,  654,  675,  678,  704,  716,
      721,  727,    0,  727,  730,  546,  654,  728,  874,  869,
      735,  740,  867,  870,  871,  866,  793,  791,    0,  914,
      903,    0,  909,  789,  948,  901,  912,  962,  976,  915,
      995, 1007,  947,  922,  971,  921,  983,  994,  866,  996,
      998, 1010, 1016, 1004, 1020, 1043, 1017,  889, 1008, 1021,

     1048, 1053,  522, 4164,  379,  800, 4164, 4164,    0,  752,
      737, 4164,    0,  793,    0, 1101,  632, 4164, 1086,  739,
     4164, 1088, 4164,  635, 4164, 1090, 1108, 1128,    0, 1135,
      742, 4164, 1098, 4164,  490,    0, 1095, 4164, 4164, 4164,
     4164,    0, 1090, 1003,    0,    0, 1063,    0, 1104, 1102,
     1156, 4164,  677, 4164, 1193, 1171, 1185,  667, 1279,  641,
        0,    0,    0,    0, 1100, 1106, 1236,  556, 1253, 1254,
     1258, 1241, 1252, 1250, 1244, 1247, 1251, 1252, 1254, 1265,
     1266,    0, 1257, 1258, 1270, 1271,    0, 1159, 4164, 1179,
      374,  732, 1324, 1337, 1348, 1332, 1296, 1306, 1342, 1347,

     1341, 1345, 1349, 1346, 1352, 1353, 1354, 1360, 1398, 1399,
     1272, 1396, 1397, 1409, 1410, 1439,  966,    0, 1019,    0,
     1286,    0, 1288,    0,    0,    0, 1295,    0, 1302, 1362,
      580, 4164,  575,    0,    0,    0, 1383,  491, 1387, 1279,
     1398,    0, 1417, 1418, 1403, 1403,  478, 1413, 1421, 1411,
     1422, 1431, 1416, 1425,    0, 1436,  676, 1436, 1306, 1485,
     1489, 1456, 1450, 1457, 1463, 1458, 1472, 1478, 1471, 1473,
     1475, 1470, 1483, 1484, 1504, 1496, 1510, 1499, 1481, 1515,
     1517, 1519, 1558, 1542,    0, 1545,    0, 1553,    0, 1562,
        0, 1541, 1527,    0, 1537, 1547, 1557, 1541, 1542, 1560,

     1553, 1593, 1554, 1554, 1569, 1560, 1564, 1562, 1571,    0,
     1577, 1582, 1573,    0,  539,  928, 1579, 1595, 1590, 1608,
     1586, 1642, 1587, 1607, 1618, 1623, 1627, 1636, 1610, 1619,
     1645, 1641, 1632,  743, 1632, 1632, 1715, 1648, 1649, 1643,
     1669, 1665, 1722, 1733, 4164,  459, 1658, 1737, 1740, 1688,
     1679,  456, 1680, 1682, 1689, 1131,  940, 1744, 1722, 1716,
     1713, 1765, 1712, 1776, 1787, 1723, 1733, 1732, 1756, 1759,
     1766, 1728,  736, 1817, 4164, 1769, 1761, 1777, 1764,    0,
     1820, 4164, 1765, 1784, 1848, 4164, 1851, 4164, 1790, 1262,
     1775, 1862, 1792, 1797, 1703, 4164, 1828, 1818, 1807, 1804,

     1835, 1827, 1880, 1846, 1854, 1813, 1831, 1833, 1901,    0,
     1829, 1863, 1829, 1858, 1926, 1842, 1929, 4164, 1932, 1943,
     1893, 1950, 1849, 1899, 1954, 1957, 1961,  446, 1863, 1871,
     1972, 4164, 1975, 1877, 1915, 1926, 1997, 4164, 1937, 2001,
     4164, 2004, 4164, 1941, 1945, 1949, 1954, 2027, 4164, 1944,
     2031, 1955, 1952, 2003,    0,  431, 1961, 1962, 2038, 4164,
     1977, 1973, 1985, 1998, 1996, 2057, 2008, 2004, 2013,    0,
        0, 2060, 4164, 2012,  325, 2030, 2013, 2008, 2024, 2023,
     2022, 2045, 2020, 2045, 2040, 2038, 2050, 2051, 2063, 2063,
     2067, 2065,    0, 2068, 2057, 2065,  260, 2102, 4164, 4164,

     2173, 2201, 2229, 2257, 2285, 2313, 2321, 2348, 2376, 2396,
     2411, 2437, 2457, 2477, 2504, 2526, 2546, 2574, 2602, 2619,
     2647, 2675, 2693, 2721, 2749, 2777, 2801, 2829, 2844, 2872,
     2900, 2928, 2956, 2984, 3004, 3019, 3045, 3065, 3082, 3103,
     3126, 3153, 3178, 3201, 3222, 3250, 3273, 3299, 3316, 3344,
     3372, 3390, 3418, 3441, 3468, 3491, 3518, 3541, 3564, 3588,
     3616, 3639, 3653, 3663, 3691, 3719, 3747, 3775, 3803, 3831,
     3859, 3887, 3907, 3931, 3955, 3978, 3999, 4027, 4042, 4052,
     4062, 4072, 4082, 4092, 4102, 4112, 4135
    } ;

static yyconst flex_int16_t yy_def[688] =
    {   0,
      600,  600,  600,    3,  601,  601,  602,  602,  603,  603,
      600,   11,  604,  604,  600,   15,  600,  600,  600,  600,
      605,  606,  607,  600,  600,  600,  608,  608,  609,  610,
      611,  610,  610,  610,  610,  610,  610,  610,  610,  610,
      610,  610,  610,  610,  610,  600,  600,  608,  612,  613,
      614,  615,  616,  617,  617,  617,   56,   56,   56,   56,
       56,   56,   56,   56,   56,   56,   56,   56,  600,  600,
      600,  618,  619,  600,  600,  600,  600,  620,  600,  600,
      621,  621,  600,  622,  600,  600,  600,  600,  600,  600,
      600,  623,  600,  600,  600,  624,  625,  600,  600,  600,

      600,  600,  600,  600,  626,  627,  600,  600,  628,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  629,  629,  629,  629,  629,  629,  629,  629,
      629,  600,  600,  630,  631,  600,  600,  600,  632,  632,
      633,  634,  600,  635,  636,  635,  635,  635,  635,  635,
      635,  635,  635,  635,  635,  635,  635,  635,  635,  635,
      635,  635,  635,  635,  635,  635,  637,  638,  639,  640,
      638,  641,  600,  639,  642,  640,  640,  643,  644,  635,
      645,  645,  182,  182,  182,  182,  182,  182,  182,  182,
      182,  182,  182,  182,  182,  182,  182,  182,  182,  182,

      182,  182,  646,  600,  647,  648,  600,  600,  649,  650,
      650,  600,  651,  600,  652,  600,  653,  600,  654,  655,
      600,  656,  600,  657,  600,  658,  659,  659,  660,  659,
      661,  600,  662,  600,  600,  663,  600,  600,  600,  600,
      600,  664,  664,  664,  664,  664,  664,  664,  664,  664,
      600,  600,  665,  600,  600,  600,  600,  666,  667,  668,
      669,  670,  671,  672,  673,  673,  673,  673,  673,  673,
      673,  673,  673,  673,  673,  673,  673,  673,  673,  673,
      673,  673,  673,  673,  673,  673,  674,  600,  600,  667,
      600,  675,  676,  677,  677,  295,  295,  295,  295,  295,

      295,  295,  295,  295,  295,  295,  295,  295,  295,  295,
      295,  295,  295,  295,  295,  678,  600,  679,  600,  680,
      600,  681,  600,  682,  663,  664,  664,  664,  664,  664,
      666,  600,  668,  669,  670,  672,  673,  673,  673,  673,
      673,  673,  673,  673,  673,  673,  673,  673,  673,  673,
      673,  673,  673,  673,  673,  673,  673,  673,  675,  675,
      675,  295,  295,  295,  295,  295,  295,  295,  295,  295,
      295,  295,  295,  295,  295,  295,  295,  295,  295,  295,
      295,  295,  678,  600,  683,  600,  684,  600,  685,  600,
      686,  664,  664,  664,  673,  673,  673,  673,  673,  673,

      673,  673,  673,  673,  673,  673,  673,  673,  673,  673,
      673,  673,  673,  673,  600,  600,  295,  295,  295,  295,
      295,  295,  295,  295,  295,  295,  295,  295,  295,  295,
      295,  295,  295,  678,  664,  664,  673,  673,  673,  673,
      673,  673,  673,  600,  600,  673,  673,  673,  673,  673,
      673,  673,  673,  673,  673,  600,  687,  295,  295,  295,
      295,  295,  295,  295,  295,  295,  295,  295,  295,  295,
      295,  664,  664,  600,  600,  673,  673,  673,  673,  673,
      600,  600,  673,  673,  600,  600,  600,  600,  673,  673,
      673,  673,  673,  673,  687,  600,  687,  295,  295,  295,

      295,  295,  295,  295,  295,  664,  664,  673,  673,  673,
      673,  673,  673,  673,  673,  673,  600,  600,  673,  673,
      687,  295,  295,  295,  295,  295,  295,  664,  664,  673,
      600,  600,  673,  673,  673,  673,  600,  600,  673,  600,
      600,  600,  600,  295,  664,  664,  673,  600,  600,  673,
      673,  673,  673,  295,  664,  664,  673,  673,  600,  600,
      673,  673,  295,  664,  673,  673,  673,  673,  295,  664,
      673,  600,  600,  673,  673,  295,  673,  673,  295,  673,
      673,  295,  673,  673,  295,  673,  673,  295,  673,  673,
      295,  673,  673,  295,  673,  295,  673,  295,  600,    0,

      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600
    } ;

static yyconst flex_uint16_t yy_nxt[4252] =
    {   0,
       18,   19,   20,   19,   21,   18,   22,   23,   18,   24,
       18,   18,   18,   25,   26,   18,   27,   28,   29,   30,
       30,   30,   31,   18,   18,   18,   28,   28,   28,   32,
       30,   33,   34,   35,   36,   37,   30,   38,   30,   30,
       39,   40,   30,   30,   41,   30,   42,   43,   44,   45,
       30,   30,   30,   30,   30,   18,   18,   18,   28,   30,
       32,   30,   33,   34,   35,   36,   37,   30,   38,   30,
       39,   40,   30,   30,   41,   30,   42,   43,   44,   45,
       30,   30,   30,   30,   46,   47,   48,   18,   49,   20,
       49,   21,   18,   22,   23,   18,   24,   18,   18,   18,

       50,   51,   18,   52,   28,   29,   30,   30,   30,   53,
       18,   18,   18,   28,   28,   28,   54,   55,   56,   57,
       58,   59,   60,   55,   61,   55,   55,   62,   63,   55,
       55,   64,   55,   65,   66,   67,   68,   55,   55,   55,
       55,   55,   18,   18,   18,   28,   30,   54,   55,   56,
       57,   58,   59,   60,   55,   61,   55,   62,   63,   55,
       55,   64,   55,   65,   66,   67,   68,   55,   55,   55,
       55,   46,   47,   48,   69,   70,   71,   70,   69,   72,
       73,   69,   69,   69,   69,   69,   74,   69,   69,   75,
       69,   69,   76,   69,   69,   69,   69,   69,   69,   77,

       69,   69,   69,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   79,
       69,   80,   69,   69,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   69,   69,
       69,   82,   82,   85,   85,   85,   85,   85,   85,   87,
      140,  599,   83,   83,   87,  141,   88,   88,   88,  238,
      239,   88,   88,   88,   89,   90,   91,   90,   89,   89,
       89,   89,   89,   89,   89,   89,   89,   89,   89,   89,

       89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
       89,   89,   89,   92,   92,   92,   92,   92,   92,   92,
       92,   92,   92,   92,   92,   92,   92,   92,   92,   92,
       92,   92,   92,   92,   92,   92,   92,   92,   92,   89,
       89,   89,   89,   89,   92,   92,   92,   92,   92,   92,
       92,   92,   92,   92,   92,   92,   92,   92,   92,   92,
       92,   92,   92,   92,   92,   92,   92,   92,   89,   89,
       89,   94,   95,   94,  172,   96,  172,  291,  173,  173,
       97,   98,   99,  262,  578,  100,   94,   95,   94,  292,
       96,  214,  214,  214,  139,   97,   98,   99,  316,  316,

      100,  101,  102,  103,  102,  104,  105,  101,  106,  107,
      108,  109,  110,  111,  112,  113,  114,  115,  101,  116,
      117,  118,  118,  101,  119,  120,  121,  122,  101,  101,
      123,  124,  125,  126,  124,  124,  124,  124,  127,  124,
      124,  124,  124,  128,  129,  124,  124,  124,  130,  131,
      124,  124,  124,  124,  124,  124,  132,  101,  133,  101,
      101,  123,  124,  125,  126,  124,  124,  124,  124,  127,
      124,  124,  124,  128,  129,  124,  124,  124,  130,  131,
      124,  124,  124,  124,  124,  101,  101,  101,  146,  147,
      564,  153,  149,  150,  151,  152,  155,  156,  204,  154,

      158,  162,  221,  148,  164,  545,  166,  218,  165,  235,
      235,  157,  225,  250,  160,  491,  163,  159,  483,  146,
      147,  149,  153,  150,  151,  152,  155,  204,  156,  154,
      161,  158,  162,  148,  232,  164,  166,  404,  167,  165,
      167,  157,  415,  176,  250,  160,  163,  159,  222,  205,
      396,  169,  177,  169,  416,  145,  145,  145,  219,  170,
      161,  139,  139,  226,  139,  139,  139,  139,  139,  139,
      139,  139,  139,  139,  140,  139,  139,  332,  205,  141,
      233,  181,  332,  274,  139,  139,  139,  139,  139,  139,
      171,  144,  179,  144,  172,  187,  180,  180,  144,  243,

      144,  235,  235,  171,  144,  179,  144,  172,  182,  180,
      180,  144,  181,  144,  274,  341,  139,  139,  139,  139,
      139,  216,  216,  216,  181,  187,  216,  216,  216,  243,
      181,  237,  237,  237,  236,  244,  144,  218,  181,  182,
      225,  186,  245,  332,  181,  139,  139,  139,  185,  144,
      171,  144,  179,  144,  172,  181,  180,  180,  144,  181,
      144,  181,  181,  236,  181,  244,  183,  189,  181,  332,
      188,  186,  245,  181,  181,  190,  181,  185,  191,  254,
      184,  251,  252,  251,  246,  192,  275,  194,  219,  247,
      181,  226,  248,  181,  249,  181,  144,  183,  189,  193,

      188,  181,  265,  181,  195,  190,  181,  181,  191,  181,
      184,  196,  181,  198,  246,  266,  192,  275,  194,  247,
      267,  181,  248,  181,  249,  202,  181,  197,  199,  193,
      413,  181,  265,  181,  195,  359,  360,  200,  181,  211,
      181,  201,  196,  181,  198,  266,  268,  181,  204,  221,
      267,  181,  232,  181,  211,  202,  181,  197,  199,  413,
      256,  257,  256,  269,  181,  258,  227,  270,  200,  228,
      271,  272,  201,  273,  276,  281,  268,  181,  229,  227,
      228,  229,  229,  229,  259,  257,  259,  507,  282,  260,
      288,  289,  288,  269,  167,  222,  167,  270,  233,  205,

      271,  272,  207,  273,  276,  281,  172,  169,  172,  169,
      173,  173,  214,  214,  214,  170,  507,  229,  282,  229,
      253,  253,  254,  253,  253,  253,  253,  253,  253,  253,
      253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
      253,  253,  253,  253,  253,  253,  253,  253,  253,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  253,  253,  253,  253,  253,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,

      255,  255,  255,  255,  253,  253,  253,  277,  600,  279,
      283,  284,  285,  286,  181,  291,  280,  278,  172,  600,
      172,  176,  173,  173,  172,  264,  172,  292,  173,  173,
      179,  456,  172,  457,  180,  180,  136,  311,  277,  279,
      283,  284,  285,  286,  181,  496,  280,  278,  139,  290,
      289,  290,  139,  139,  139,  139,  139,  139,  139,  139,
      139,  139,  139,  139,  296,  291,  139,  311,  298,  181,
      181,  139,  139,  139,  139,  139,  139,  292,  177,  241,
      287,  145,  145,  145,  264,  384,  384,  295,  240,  287,
      144,  234,  144,  287,  296,  181,  497,  144,  298,  181,

      181,  287,  223,  139,  139,  139,  139,  139,  171,  144,
      179,  144,  172,  297,  180,  180,  144,  295,  144,  181,
      171,  144,  179,  144,  172,  181,  180,  180,  144,  299,
      144,  181,  139,  139,  139,  144,  212,  300,  386,  386,
      301,  302,  181,  297,  181,  327,  181,  303,  304,  181,
      305,  312,  181,  306,  144,  294,  181,  310,  181,  299,
      211,  181,  313,  307,  181,  181,  144,  300,  181,  181,
      301,  302,  181,  211,  181,  327,  181,  208,  303,  304,
      305,  312,  181,  308,  306,  294,  181,  310,  181,  314,
      309,  181,  313,  307,  181,  181,  181,  207,  181,  181,

      315,  181,  216,  216,  216,  317,  317,  319,  319,  321,
      321,  328,  229,  308,  237,  237,  237,  323,  323,  314,
      309,  181,  326,  138,  229,  229,  181,  229,  229,  229,
      315,  181,  229,  329,  456,  330,  457,  337,  318,  229,
      320,  328,  322,  143,  229,  229,  338,  229,  229,  229,
      324,  229,  229,  326,  229,  229,  229,  251,  252,  251,
      288,  289,  288,  229,  329,  229,  330,  318,  337,  320,
      138,  322,  256,  257,  256,  136,  338,  258,  600,  324,
      290,  289,  290,  229,  600,  229,  256,  257,  256,  600,
      229,  258,  229,  253,  253,  254,  253,  253,  253,  253,

      253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
      253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
      253,  253,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  253,  253,
      253,  253,  253,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  253,  253,  253,
      259,  257,  259,  339,  340,  260,  342,  343,  344,  600,
      345,  346,  347,  348,  349,  350,  351,  352,  353,  354,

      600,  355,  356,  357,  358,  388,  388,  390,  390,  359,
      360,  600,  181,  339,  340,  515,  398,  342,  343,  344,
      345,  346,  347,  348,  349,  350,  351,  352,  287,  353,
      354,  355,  356,  600,  357,  358,  181,  287,  144,  366,
      144,  287,  181,  392,  515,  144,  181,  398,  393,  287,
      171,  144,  179,  144,  172,  341,  180,  180,  144,  600,
      144,  171,  144,  179,  144,  172,  181,  180,  180,  144,
      366,  144,  181,  392,  362,  367,  181,  368,  393,  364,
      365,  181,  181,  144,  370,  181,  181,  181,  363,  181,
      369,  371,  181,  181,  181,  372,  144,  374,  375,  373,

      181,  600,  181,  376,  394,  362,  367,  144,  368,  364,
      365,  181,  181,  600,  370,  181,  181,  181,  363,  181,
      369,  371,  181,  181,  181,  372,  395,  374,  375,  373,
      181,  377,  378,  376,  394,  397,  181,  181,  181,  181,
      379,  380,  381,  382,  204,  399,  400,  401,  600,  181,
      181,  402,  403,  405,  406,  408,  395,  407,  383,  383,
      409,  600,  377,  378,  410,  397,  181,  181,  181,  181,
      379,  380,  411,  381,  382,  399,  412,  400,  401,  181,
      181,  402,  403,  405,  414,  406,  408,  407,  600,  600,
      181,  409,  415,  600,  410,  205,  181,  181,  181,  417,

      419,  420,  411,  181,  416,  418,  412,  421,  600,  396,
      424,  181,  181,  181,  414,  181,  425,  600,  181,  422,
      181,  181,  423,  181,  181,  428,  181,  181,  181,  417,
      426,  419,  420,  181,  404,  418,  181,  427,  421,  181,
      424,  181,  181,  181,  181,  181,  430,  425,  181,  422,
      181,  181,  423,  181,  181,  431,  428,  181,  429,  181,
      426,  217,  217,  204,  220,  220,  181,  433,  427,  181,
      435,  432,  224,  224,  181,  436,  430,  434,  434,  437,
      181,  231,  231,  440,  438,  431,  439,  181,  429,  181,
      441,  442,  600,  443,  444,  444,  444,  433,  446,  447,

      432,  435,  448,  452,  445,  436,  449,  450,  451,  437,
      453,  454,  600,  440,  205,  438,  455,  439,  600,  181,
      441,  458,  442,  443,  459,  600,  462,  181,  446,  447,
      181,  463,  460,  448,  452,  181,  449,  450,  451,  461,
      464,  453,  454,  444,  444,  444,  455,  181,  181,  181,
      181,  458,  469,  445,  600,  459,  462,  181,  181,  181,
      181,  463,  460,  181,  465,  181,  466,  181,  468,  472,
      461,  464,  181,  467,  470,  600,  181,  181,  181,  473,
      181,  181,  181,  469,  471,  181,  600,  600,  181,  181,
      476,  477,  478,  181,  465,  600,  466,  181,  479,  468,

      472,  480,  181,  467,  600,  470,  181,  484,  496,  473,
      600,  181,  181,  600,  471,  181,  474,  474,  474,  489,
      476,  477,  478,  481,  481,  481,  475,  490,  492,  479,
      493,  494,  480,  482,  444,  444,  444,  484,  485,  485,
      485,  487,  487,  487,  445,  474,  474,  474,  486,  500,
      489,  488,  181,  181,  501,  475,  181,  490,  492,  497,
      493,  494,  181,  181,  498,  499,  481,  481,  481,  600,
      506,  483,  181,  181,  600,  600,  482,  485,  485,  485,
      500,  502,  181,  181,  181,  501,  181,  486,  487,  487,
      487,  491,  181,  181,  498,  499,  181,  600,  488,  181,

      506,  508,  181,  181,  503,  181,  181,  504,  505,  509,
      510,  502,  511,  512,  181,  516,  181,  513,  474,  474,
      474,  481,  481,  481,  514,  519,  181,  181,  475,  181,
      520,  482,  508,  521,  503,  181,  181,  504,  505,  509,
      523,  510,  511,  512,  181,  516,  181,  181,  513,  485,
      485,  485,  487,  487,  487,  514,  519,  181,  181,  486,
      528,  520,  488,  517,  517,  517,  522,  181,  529,  524,
      530,  523,  600,  518,  181,  181,  533,  181,  535,  526,
      525,  517,  517,  517,  497,  539,  181,  527,  181,  181,
      528,  518,  534,  600,  181,  536,  522,  181,  496,  529,

      524,  530,  531,  531,  531,  181,  533,  550,  535,  525,
      526,  546,  532,  600,  600,  539,  181,  547,  527,  181,
      181,  600,  600,  534,  181,  600,  536,  537,  537,  537,
      517,  517,  517,  540,  540,  540,  544,  538,  550,  181,
      518,  546,  600,  541,  542,  542,  542,  547,  551,  497,
      181,  531,  531,  531,  543,  537,  537,  537,  540,  540,
      540,  532,  542,  542,  542,  538,  552,  544,  541,  181,
      600,  600,  543,  531,  531,  531,  548,  548,  548,  551,
      553,  554,  555,  532,  558,  556,  549,  557,  561,  600,
      181,  562,  565,  600,  181,  566,  552,  181,  537,  537,

      537,  181,  540,  540,  540,  542,  542,  542,  538,  600,
      553,  554,  541,  555,  558,  543,  556,  567,  557,  561,
      181,  562,  568,  565,  181,  569,  566,  181,  548,  548,
      548,  181,  559,  559,  559,  570,  563,  600,  549,  559,
      559,  559,  560,  181,  571,  574,  580,  567,  575,  560,
      576,  584,  568,  181,  577,  569,  581,  582,  572,  572,
      572,  572,  572,  572,  181,  583,  570,  563,  573,  586,
      181,  573,  579,  181,  571,  587,  574,  580,  575,  589,
      181,  576,  584,  181,  577,  181,  581,  585,  582,  588,
      590,  181,  591,  592,  181,  583,  593,  594,  595,  586,

      181,  596,  579,  597,  600,  181,  587,  181,  181,  589,
      181,  598,  600,  599,  600,  181,  600,  585,  600,  588,
      590,  181,  591,  600,  592,  600,  600,  593,  594,  595,
      600,  600,  596,  597,  600,  181,  600,  181,  181,  600,
      600,  598,  181,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  181,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,

       81,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   86,
       86,   86,   86,   86,   86,   86,   86,   86,   86,   86,
       86,   86,   86,   86,   86,   86,   86,   86,   86,   86,
       86,   86,   86,   86,   86,   86,   86,   93,   93,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
       93,   93,   93,   93,   93,  134,  600,  600,  600,  134,
      134,  134,  134,  134,  134,  134,  134,  134,  134,  134,

      134,  134,  134,  134,  134,  134,  134,  134,  134,  134,
      134,  134,  134,  135,  135,  135,  135,  135,  135,  135,
      135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
      135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
      135,  137,  137,  137,  137,  137,  137,  137,  139,  139,
      600,  139,  139,  139,  139,  139,  139,  139,  139,  139,
      139,  139,  139,  139,  139,  139,  139,  139,  139,  139,
      139,  139,  139,  139,  139,  139,  142,  142,  142,  142,
      142,  142,  142,  142,  142,  142,  142,  142,  142,  142,
      142,  142,  142,  142,  142,  142,  142,  142,  142,  142,

      142,  142,  142,  142,  144,  144,  144,  600,  600,  144,
      144,  600,  144,  600,  600,  600,  144,  144,  144,  144,
      144,  144,  144,  144,  145,  145,  600,  600,  600,  600,
      600,  145,  145,  145,  145,  145,  145,  145,  168,  600,
      168,  600,  600,  600,  168,  168,  600,  168,  600,  600,
      600,  600,  168,  600,  600,  600,  600,  168,  168,  168,
      168,  168,  168,  168,  171,  600,  171,  600,  171,  600,
      171,  600,  600,  600,  600,  600,  600,  171,  171,  171,
      171,  171,  171,  171,  174,  600,  600,  174,  174,  600,
      174,  174,  174,  600,  600,  600,  600,  174,  174,  174,

      174,  174,  174,  174,  175,  175,  600,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  178,  600,  600,  600,  178,  600,  600,  178,
      178,  600,  600,  600,  600,  600,  178,  178,  178,  178,
      178,  178,  178,  181,  181,  181,  181,  181,  600,  181,
      181,  600,  181,  600,  600,  600,  181,  181,  181,  181,
      181,  181,  181,  181,  203,  203,  203,  203,  203,  203,
      203,  203,  203,  203,  203,  203,  203,  203,  203,  203,
      203,  203,  203,  203,  203,  203,  203,  203,  203,  203,

      203,  203,  206,  206,  206,  206,  206,  206,  206,  206,
      206,  206,  206,  206,  206,  206,  206,  206,  206,  206,
      206,  206,  206,  206,  206,  206,  206,  206,  206,  206,
      209,  600,  209,  209,  600,  600,  600,  600,  600,  209,
      209,  209,  209,  209,  209,  209,  209,  210,  210,  210,
      210,  210,  210,  210,  600,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  213,  600,  600,  600,  213,
      213,  213,  213,  213,  213,  213,  213,  213,  213,  213,
      213,  213,  213,  213,  213,  213,  213,  213,  213,  213,

      213,  213,  213,  215,  215,  600,  215,  215,  600,  600,
      600,  600,  600,  215,  215,  215,  215,  215,  215,  215,
      215,  217,  217,  217,  217,  217,  217,  600,  217,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  217,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  224,  224,  224,
      224,  224,  224,  600,  224,  224,  224,  224,  224,  224,
      224,  224,  224,  224,  224,  224,  224,  224,  224,  224,

      224,  224,  224,  224,  224,  230,  600,  230,  600,  600,
      600,  230,  230,  230,  230,  230,  600,  600,  600,  600,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  231,
      231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
      231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
      231,  231,  231,  231,  231,  231,  231,  242,  242,  600,
      600,  600,  600,  600,  242,  242,  242,  242,  242,  242,
      242,  242,  134,  134,  134,  134,  134,  134,  134,  134,
      134,  134,  134,  134,  134,  134,  134,  134,  134,  134,
      134,  134,  134,  134,  134,  134,  134,  134,  134,  134,

      135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
      135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
      135,  135,  135,  135,  135,  135,  135,  135,  139,  139,
      600,  139,  139,  139,  139,  139,  139,  139,  139,  139,
      139,  139,  139,  139,  139,  139,  139,  139,  139,  139,
      139,  139,  139,  139,  139,  139,  261,  261,  261,  261,
      261,  261,  261,  261,  261,  261,  261,  261,  261,  261,
      261,  261,  261,  261,  261,  261,  261,  261,  261,  261,
      261,  261,  261,  261,  263,  263,  600,  263,  263,  263,
      263,  263,  263,  263,  263,  263,  263,  263,  263,  263,

      263,  263,  263,  263,  263,  263,  263,  263,  263,  263,
      263,  263,  144,  144,  144,  600,  600,  144,  144,  600,
      144,  600,  600,  600,  144,  144,  144,  144,  144,  144,
      144,  144,  145,  145,  145,  600,  600,  600,  600,  145,
      145,  145,  145,  145,  145,  145,  168,  600,  168,  600,
      600,  600,  168,  168,  600,  168,  600,  600,  600,  600,
      168,  600,  600,  600,  600,  168,  168,  168,  168,  168,
      168,  168,  171,  600,  171,  600,  171,  600,  171,  600,
      600,  600,  600,  600,  600,  171,  171,  171,  171,  171,
      171,  171,  174,  174,  600,  174,  174,  174,  600,  600,

      600,  600,  174,  174,  174,  174,  174,  174,  174,  177,
      600,  600,  600,  177,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  177,  177,  177,  177,  177,  177,  177,
      287,  600,  600,  287,  600,  287,  600,  287,  600,  287,
      600,  600,  287,  287,  600,  600,  287,  287,  287,  287,
      287,  287,  287,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  178,  600,  600,  600,  600,  600,  178,  178,  600,
      600,  178,  178,  178,  600,  600,  600,  600,  178,  178,

      178,  178,  178,  178,  178,  293,  600,  600,  293,  293,
      293,  293,  293,  600,  293,  293,  600,  293,  293,  600,
      600,  293,  293,  293,  293,  293,  293,  293,  293,  181,
      181,  181,  181,  181,  600,  181,  181,  600,  181,  600,
      600,  600,  181,  181,  181,  181,  181,  181,  181,  181,
      203,  203,  203,  203,  203,  203,  203,  203,  203,  203,
      203,  203,  203,  203,  203,  203,  203,  203,  203,  203,
      203,  203,  203,  203,  203,  203,  203,  203,  203,  600,
      600,  600,  600,  600,  600,  600,  203,  600,  600,  600,
      600,  203,  600,  203,  203,  600,  600,  203,  203,  206,

      206,  206,  206,  206,  206,  206,  206,  206,  206,  206,
      206,  206,  206,  206,  206,  206,  206,  206,  206,  206,
      206,  206,  206,  206,  206,  206,  206,  209,  600,  209,
      209,  600,  600,  600,  600,  600,  209,  209,  209,  209,
      209,  209,  209,  209,  210,  210,  210,  210,  210,  210,
      210,  600,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  213,  600,  600,  600,  213,  213,  213,  213,
      213,  213,  213,  213,  213,  213,  213,  213,  213,  213,
      213,  213,  213,  213,  213,  213,  213,  213,  213,  213,

      215,  215,  600,  215,  215,  600,  600,  600,  600,  600,
      215,  215,  215,  215,  215,  215,  215,  215,  217,  217,
      217,  217,  217,  217,  600,  217,  217,  217,  217,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  600,  600,
      600,  600,  600,  600,  217,  600,  600,  600,  600,  600,
      600,  600,  217,  600,  600,  217,  600,  217,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  600,  600,

      600,  600,  600,  600,  220,  600,  600,  600,  600,  600,
      600,  600,  220,  600,  600,  220,  600,  220,  224,  224,
      224,  224,  224,  224,  600,  224,  224,  224,  224,  224,
      224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
      224,  224,  224,  224,  224,  224,  224,  224,  600,  600,
      600,  600,  600,  600,  224,  600,  600,  600,  600,  600,
      600,  600,  224,  600,  600,  224,  600,  224,  230,  600,
      600,  600,  600,  600,  230,  230,  600,  230,  230,  600,
      600,  600,  600,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  229,  600,  600,  600,  600,  600,  229,  229,

      600,  229,  229,  600,  600,  600,  600,  229,  229,  229,
      229,  229,  229,  229,  229,  229,  231,  231,  231,  231,
      231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
      231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
      231,  231,  231,  231,  231,  231,  600,  600,  600,  600,
      600,  600,  231,  600,  600,  600,  600,  600,  600,  600,
      231,  600,  600,  231,  600,  231,  325,  325,  600,  600,
      600,  600,  600,  325,  325,  325,  242,  242,  600,  600,
      600,  600,  600,  242,  242,  242,  242,  242,  242,  242,
      242,  253,  253,  253,  253,  253,  253,  253,  253,  253,

      253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
      253,  253,  253,  253,  253,  253,  253,  253,  253,  331,
      331,  331,  331,  331,  331,  331,  331,  331,  331,  331,
      331,  331,  331,  331,  331,  331,  331,  331,  331,  331,
      331,  331,  331,  331,  331,  331,  331,  139,  139,  139,
      139,  139,  139,  139,  139,  139,  139,  139,  139,  139,
      139,  139,  139,  139,  139,  139,  139,  139,  139,  139,
      139,  139,  139,  139,  139,  333,  333,  333,  333,  333,
      333,  333,  333,  333,  333,  333,  333,  333,  333,  333,
      333,  333,  333,  333,  333,  333,  333,  333,  333,  333,

      333,  333,  333,  334,  334,  600,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
      334,  335,  335,  600,  335,  335,  335,  335,  335,  335,
      335,  335,  335,  335,  335,  335,  335,  335,  335,  335,
      335,  335,  335,  335,  335,  335,  335,  335,  335,  263,
      263,  600,  263,  263,  263,  263,  263,  263,  263,  263,
      263,  263,  263,  263,  263,  263,  263,  263,  263,  263,
      263,  263,  263,  263,  263,  263,  263,  336,  336,  600,
      336,  336,  336,  336,  336,  336,  336,  336,  336,  336,

      336,  336,  336,  336,  336,  336,  336,  336,  336,  336,
      336,  336,  336,  336,  336,  144,  144,  144,  600,  600,
      144,  144,  600,  144,  600,  600,  600,  144,  144,  144,
      144,  144,  144,  144,  144,  287,  600,  600,  287,  600,
      287,  600,  287,  600,  287,  600,  600,  287,  287,  600,
      600,  287,  287,  287,  287,  287,  287,  287,  361,  361,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  361,  361,  361,  361,  361,
      361,  361,  293,  600,  600,  293,  293,  293,  293,  293,
      600,  293,  293,  600,  293,  293,  600,  600,  293,  293,

      293,  293,  293,  293,  293,  293,  181,  181,  181,  181,
      181,  600,  181,  181,  600,  181,  600,  600,  600,  181,
      181,  181,  181,  181,  181,  181,  181,  203,  203,  203,
      203,  203,  203,  203,  203,  203,  203,  203,  203,  203,
      203,  203,  203,  203,  203,  203,  203,  203,  203,  203,
      203,  203,  203,  203,  203,  385,  385,  600,  600,  600,
      600,  600,  385,  385,  385,  387,  387,  600,  600,  600,
      600,  600,  387,  387,  387,  389,  389,  600,  600,  600,
      600,  600,  389,  389,  389,  391,  391,  600,  600,  600,
      600,  600,  391,  391,  391,  217,  217,  600,  600,  600,

      600,  600,  217,  217,  217,  220,  220,  600,  600,  600,
      600,  600,  220,  220,  220,  224,  224,  600,  600,  600,
      600,  600,  224,  224,  224,  231,  231,  600,  600,  600,
      600,  600,  231,  231,  231,  495,  495,  495,  495,  495,
      495,  495,  495,  495,  495,  495,  495,  495,  495,  495,
      495,  495,  495,  495,  495,  495,  495,  495,  495,  495,
      495,  495,  495,   17,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,

      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600
    } ;

static yyconst flex_int16_t yy_chk[4252] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    5,    6,    7,    7,    7,    8,    8,    8,    9,
       27,  597,    5,    6,   10,   27,    9,    9,    9,  120,
      120,   10,   10,   10,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   13,   13,   13,   50,   13,   50,  291,   50,   50,
       13,   13,   13,  141,  575,   13,   14,   14,   14,  291,
       14,   88,   88,   88,  141,   14,   14,   14,  205,  205,

       14,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   32,   33,
      556,   38,   34,   35,   36,   37,   39,   40,   72,   38,

       41,   43,   97,   33,   44,  528,   45,   96,   44,  235,
      235,   40,  105,  131,   42,  452,   43,   41,  446,   32,
       33,   34,   38,   35,   36,   37,   39,  203,   40,   38,
       42,   41,   43,   33,  109,   44,   45,  347,   49,   44,
       49,   40,  415,   53,  131,   42,   43,   41,   97,   72,
      338,   49,   53,   49,  415,   53,   53,   53,   96,   49,
       42,   52,   52,  105,   52,   52,   52,   52,   52,   52,
       52,   52,   52,   52,   52,   52,   52,  333,  203,   52,
      109,   59,  331,  156,   52,   52,   52,   52,   52,   52,
       54,   54,   54,   54,   54,   59,   54,   54,   54,  123,

       54,  117,  117,   55,   55,   55,   55,   55,   54,   55,
       55,   55,   59,   55,  156,  268,   52,   52,   52,   52,
       52,   94,   94,   94,   57,   59,   95,   95,   95,  123,
       58,  118,  118,  118,  117,  125,   54,  217,   57,   54,
      224,   58,  126,  260,   58,   52,   52,   52,   57,   55,
       56,   56,   56,   56,   56,   57,   56,   56,   56,   60,
       56,   58,   61,  117,   62,  125,   56,   61,   57,  258,
       60,   58,  126,   60,   58,   61,   61,   57,   62,  253,
       56,  134,  134,  134,  127,   63,  157,   64,  217,  128,
       60,  224,  129,   61,  130,   62,   56,   56,   61,   63,

       60,   64,  146,   60,   64,   61,   61,   65,   62,   66,
       56,   65,   68,   66,  127,  147,   63,  157,   64,  128,
      148,   65,  129,   66,  130,   68,   68,   65,   66,   63,
      357,   64,  146,   67,   64,  292,  292,   67,   65,  211,
       66,   67,   65,   68,   66,  147,  149,   67,  434,  220,
      148,   65,  231,   66,  210,   68,   68,   65,   66,  357,
      138,  138,  138,  150,   67,  138,  106,  151,   67,  106,
      152,  154,   67,  155,  158,  161,  149,   67,  106,  106,
      106,  106,  106,  106,  140,  140,  140,  473,  162,  140,
      174,  174,  174,  150,  167,  220,  167,  151,  231,  434,

      152,  154,  206,  155,  158,  161,  168,  167,  168,  167,
      168,  168,  214,  214,  214,  167,  473,  106,  162,  106,
      137,  137,  137,  137,  137,  137,  137,  137,  137,  137,
      137,  137,  137,  137,  137,  137,  137,  137,  137,  137,
      137,  137,  137,  137,  137,  137,  137,  137,  137,  137,
      137,  137,  137,  137,  137,  137,  137,  137,  137,  137,
      137,  137,  137,  137,  137,  137,  137,  137,  137,  137,
      137,  137,  137,  137,  137,  137,  137,  137,  137,  137,
      137,  137,  137,  137,  137,  137,  137,  137,  137,  137,
      137,  137,  137,  137,  137,  137,  137,  137,  137,  137,

      137,  137,  137,  137,  137,  137,  137,  159,  176,  160,
      163,  164,  165,  166,  189,  177,  160,  159,  171,  177,
      171,  170,  171,  171,  173,  145,  173,  177,  173,  173,
      180,  416,  180,  416,  180,  180,  135,  198,  159,  160,
      163,  164,  165,  166,  189,  457,  160,  159,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  184,  178,  175,  198,  186,  186,
      184,  175,  175,  175,  175,  175,  175,  178,  178,  122,
      179,  178,  178,  178,  178,  317,  317,  183,  121,  179,
      179,  116,  179,  179,  184,  183,  457,  179,  186,  186,

      184,  179,  104,  175,  175,  175,  175,  175,  181,  181,
      181,  181,  181,  185,  181,  181,  181,  183,  181,  185,
      182,  182,  182,  182,  182,  183,  182,  182,  182,  187,
      182,  187,  175,  175,  175,  179,   83,  188,  319,  319,
      190,  191,  188,  185,  190,  244,  191,  192,  193,  185,
      194,  199,  194,  195,  181,  182,  199,  197,  192,  187,
       82,  187,  200,  195,  193,  197,  182,  188,  195,  200,
      190,  191,  188,   81,  190,  244,  191,   76,  192,  193,
      194,  199,  194,  196,  195,  182,  199,  197,  192,  201,
      196,  196,  200,  195,  193,  197,  201,   73,  195,  200,

      202,  202,  216,  216,  216,  219,  219,  222,  222,  226,
      226,  247,  227,  196,  237,  237,  237,  233,  233,  201,
      196,  196,  243,   51,  227,  227,  201,  227,  227,  227,
      202,  202,  228,  249,  456,  250,  456,  265,  219,  230,
      222,  247,  226,   29,  228,  228,  266,  228,  228,  228,
      233,  230,  230,  243,  230,  230,  230,  251,  251,  251,
      288,  288,  288,  227,  249,  227,  250,  219,  265,  222,
       26,  226,  256,  256,  256,   22,  266,  256,   17,  233,
      290,  290,  290,  228,    0,  228,  257,  257,  257,    0,
      230,  257,  230,  255,  255,  255,  255,  255,  255,  255,

      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      259,  259,  259,  267,  267,  259,  269,  270,  271,    0,
      272,  273,  274,  275,  276,  277,  278,  279,  280,  281,

        0,  283,  284,  285,  286,  321,  321,  323,  323,  359,
      359,    0,  311,  267,  267,  490,  340,  269,  270,  271,
      272,  273,  274,  275,  276,  277,  278,  279,  293,  280,
      281,  283,  284,    0,  285,  286,  297,  293,  293,  298,
      293,  293,  311,  327,  490,  293,  298,  340,  329,  293,
      294,  294,  294,  294,  294,  297,  294,  294,  294,    0,
      294,  295,  295,  295,  295,  295,  297,  295,  295,  295,
      298,  295,  296,  327,  294,  299,  298,  300,  329,  296,
      296,  301,  299,  293,  302,  302,  304,  300,  295,  303,
      301,  303,  305,  306,  307,  304,  294,  306,  307,  305,

      308,    0,  296,  308,  330,  294,  299,  295,  300,  296,
      296,  301,  299,    0,  302,  302,  304,  300,  295,  303,
      301,  303,  305,  306,  307,  304,  337,  306,  307,  305,
      308,  309,  310,  308,  330,  339,  312,  313,  309,  310,
      312,  313,  314,  315,  316,  341,  343,  344,    0,  314,
      315,  345,  346,  348,  349,  351,  337,  350,  316,  316,
      352,    0,  309,  310,  353,  339,  312,  313,  309,  310,
      312,  313,  354,  314,  315,  341,  356,  343,  344,  314,
      315,  345,  346,  348,  358,  349,  351,  350,  360,  360,
      363,  352,  361,  361,  353,  316,  362,  364,  366,  362,

      365,  367,  354,  365,  361,  364,  356,  368,    0,  363,
      372,  369,  367,  370,  358,  371,  373,    0,  368,  369,
      363,  379,  370,  373,  374,  376,  362,  364,  366,  362,
      374,  365,  367,  365,  371,  364,  376,  375,  368,  378,
      372,  369,  367,  370,  375,  371,  378,  373,  368,  369,
      377,  379,  370,  373,  374,  380,  376,  381,  377,  382,
      374,  384,  384,  383,  386,  386,  376,  382,  375,  378,
      392,  381,  388,  388,  375,  393,  378,  383,  383,  395,
      377,  390,  390,  398,  396,  380,  397,  381,  377,  382,
      399,  400,    0,  401,  402,  402,  402,  382,  403,  404,

      381,  392,  405,  409,  402,  393,  406,  407,  408,  395,
      411,  412,    0,  398,  383,  396,  413,  397,    0,  417,
      399,  417,  400,  401,  418,    0,  421,  423,  403,  404,
      419,  423,  419,  405,  409,  418,  406,  407,  408,  420,
      424,  411,  412,  422,  422,  422,  413,  424,  420,  417,
      429,  417,  430,  422,    0,  418,  421,  423,  425,  430,
      419,  423,  419,  426,  425,  418,  426,  427,  428,  435,
      420,  424,  433,  427,  431,    0,  428,  424,  420,  436,
      429,  432,  422,  430,  432,  431,    0,    0,  425,  430,
      438,  439,  440,  426,  425,    0,  426,  427,  441,  428,

      435,  442,  433,  427,    0,  431,  428,  447,  495,  436,
        0,  432,  422,    0,  432,  431,  437,  437,  437,  450,
      438,  439,  440,  443,  443,  443,  437,  451,  453,  441,
      454,  455,  442,  443,  444,  444,  444,  447,  448,  448,
      448,  449,  449,  449,  444,  458,  458,  458,  448,  461,
      450,  449,  463,  461,  466,  458,  460,  451,  453,  495,
      454,  455,  459,  466,  459,  460,  462,  462,  462,    0,
      472,  463,  468,  467,    0,    0,  462,  464,  464,  464,
      461,  467,  463,  461,  458,  466,  460,  464,  465,  465,
      465,  468,  459,  466,  459,  460,  469,    0,  465,  470,

      472,  476,  468,  467,  469,  462,  471,  470,  471,  477,
      478,  467,  479,  483,  458,  491,  464,  484,  474,  474,
      474,  481,  481,  481,  489,  493,  469,  465,  474,  470,
      494,  481,  476,  497,  469,  462,  471,  470,  471,  477,
      499,  478,  479,  483,  500,  491,  464,  499,  484,  485,
      485,  485,  487,  487,  487,  489,  493,  465,  498,  485,
      506,  494,  487,  492,  492,  492,  498,  502,  507,  501,
      508,  499,    0,  492,  500,  501,  511,  499,  513,  504,
      502,  503,  503,  503,  497,  516,  504,  505,  498,  523,
      506,  503,  512,    0,  505,  514,  498,  502,  521,  507,

      501,  508,  509,  509,  509,  501,  511,  534,  513,  502,
      504,  529,  509,    0,    0,  516,  504,  530,  505,  523,
      503,    0,    0,  512,  505,    0,  514,  515,  515,  515,
      517,  517,  517,  519,  519,  519,  524,  515,  534,  524,
      517,  529,    0,  519,  520,  520,  520,  530,  535,  521,
      503,  522,  522,  522,  520,  525,  525,  525,  526,  526,
      526,  522,  527,  527,  527,  525,  536,  524,  526,  524,
        0,    0,  527,  531,  531,  531,  533,  533,  533,  535,
      539,  544,  545,  531,  550,  546,  533,  547,  552,    0,
      522,  553,  557,    0,  525,  558,  536,  526,  537,  537,

      537,  527,  540,  540,  540,  542,  542,  542,  537,    0,
      539,  544,  540,  545,  550,  542,  546,  561,  547,  552,
      522,  553,  562,  557,  525,  563,  558,  526,  548,  548,
      548,  527,  551,  551,  551,  564,  554,    0,  548,  559,
      559,  559,  551,  554,  565,  567,  577,  561,  568,  559,
      569,  581,  562,  569,  574,  563,  578,  579,  566,  566,
      566,  572,  572,  572,  579,  580,  564,  554,  566,  583,
      576,  572,  576,  554,  565,  584,  567,  577,  568,  586,
      585,  569,  581,  569,  574,  582,  578,  582,  579,  585,
      587,  588,  588,  589,  579,  580,  590,  591,  592,  583,

      576,  594,  576,  595,    0,  596,  584,  591,  594,  586,
      585,  596,    0,  598,    0,  582,    0,  582,    0,  585,
      587,  588,  588,    0,  589,    0,    0,  590,  591,  592,
        0,    0,  594,  595,    0,  596,    0,  591,  594,    0,
        0,  596,  598,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  598,  601,  601,  601,  601,  601,  601,  601,
      601,  601,  601,  601,  601,  601,  601,  601,  601,  601,
      601,  601,  601,  601,  601,  601,  601,  601,  601,  601,

      601,  602,  602,  602,  602,  602,  602,  602,  602,  602,
      602,  602,  602,  602,  602,  602,  602,  602,  602,  602,
      602,  602,  602,  602,  602,  602,  602,  602,  602,  603,
      603,  603,  603,  603,  603,  603,  603,  603,  603,  603,
      603,  603,  603,  603,  603,  603,  603,  603,  603,  603,
      603,  603,  603,  603,  603,  603,  603,  604,  604,  604,
      604,  604,  604,  604,  604,  604,  604,  604,  604,  604,
      604,  604,  604,  604,  604,  604,  604,  604,  604,  604,
      604,  604,  604,  604,  604,  605,    0,    0,    0,  605,
      605,  605,  605,  605,  605,  605,  605,  605,  605,  605,

      605,  605,  605,  605,  605,  605,  605,  605,  605,  605,
      605,  605,  605,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  606,  606,  606,  606,  606,  606,  606,  606,  606,
      606,  607,  607,  607,  607,  607,  607,  607,  608,  608,
        0,  608,  608,  608,  608,  608,  608,  608,  608,  608,
      608,  608,  608,  608,  608,  608,  608,  608,  608,  608,
      608,  608,  608,  608,  608,  608,  609,  609,  609,  609,
      609,  609,  609,  609,  609,  609,  609,  609,  609,  609,
      609,  609,  609,  609,  609,  609,  609,  609,  609,  609,

      609,  609,  609,  609,  610,  610,  610,    0,    0,  610,
      610,    0,  610,    0,    0,    0,  610,  610,  610,  610,
      610,  610,  610,  610,  611,  611,    0,    0,    0,    0,
        0,  611,  611,  611,  611,  611,  611,  611,  612,    0,
      612,    0,    0,    0,  612,  612,    0,  612,    0,    0,
        0,    0,  612,    0,    0,    0,    0,  612,  612,  612,
      612,  612,  612,  612,  613,    0,  613,    0,  613,    0,
      613,    0,    0,    0,    0,    0,    0,  613,  613,  613,
      613,  613,  613,  613,  614,    0,    0,  614,  614,    0,
      614,  614,  614,    0,    0,    0,    0,  614,  614,  614,

      614,  614,  614,  614,  615,  615,    0,  615,  615,  615,
      615,  615,  615,  615,  615,  615,  615,  615,  615,  615,
      615,  615,  615,  615,  615,  615,  615,  615,  615,  615,
      615,  615,  616,    0,    0,    0,  616,    0,    0,  616,
      616,    0,    0,    0,    0,    0,  616,  616,  616,  616,
      616,  616,  616,  617,  617,  617,  617,  617,    0,  617,
      617,    0,  617,    0,    0,    0,  617,  617,  617,  617,
      617,  617,  617,  617,  618,  618,  618,  618,  618,  618,
      618,  618,  618,  618,  618,  618,  618,  618,  618,  618,
      618,  618,  618,  618,  618,  618,  618,  618,  618,  618,

      618,  618,  619,  619,  619,  619,  619,  619,  619,  619,
      619,  619,  619,  619,  619,  619,  619,  619,  619,  619,
      619,  619,  619,  619,  619,  619,  619,  619,  619,  619,
      620,    0,  620,  620,    0,    0,    0,    0,    0,  620,
      620,  620,  620,  620,  620,  620,  620,  621,  621,  621,
      621,  621,  621,  621,    0,  621,  621,  621,  621,  621,
      621,  621,  621,  621,  621,  621,  621,  621,  621,  621,
      621,  621,  621,  621,  621,  622,    0,    0,    0,  622,
      622,  622,  622,  622,  622,  622,  622,  622,  622,  622,
      622,  622,  622,  622,  622,  622,  622,  622,  622,  622,

      622,  622,  622,  623,  623,    0,  623,  623,    0,    0,
        0,    0,    0,  623,  623,  623,  623,  623,  623,  623,
      623,  624,  624,  624,  624,  624,  624,    0,  624,  624,
      624,  624,  624,  624,  624,  624,  624,  624,  624,  624,
      624,  624,  624,  624,  624,  624,  624,  624,  624,  625,
      625,  625,  625,  625,  625,  625,  625,  625,  625,  625,
      625,  625,  625,  625,  625,  625,  625,  625,  625,  625,
      625,  625,  625,  625,  625,  625,  625,  626,  626,  626,
      626,  626,  626,    0,  626,  626,  626,  626,  626,  626,
      626,  626,  626,  626,  626,  626,  626,  626,  626,  626,

      626,  626,  626,  626,  626,  627,    0,  627,    0,    0,
        0,  627,  627,  627,  627,  627,    0,    0,    0,    0,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  628,
      628,  628,  628,  628,  628,  628,  628,  628,  628,  628,
      628,  628,  628,  628,  628,  628,  628,  628,  628,  628,
      628,  628,  628,  628,  628,  628,  628,  629,  629,    0,
        0,    0,    0,    0,  629,  629,  629,  629,  629,  629,
      629,  629,  630,  630,  630,  630,  630,  630,  630,  630,
      630,  630,  630,  630,  630,  630,  630,  630,  630,  630,
      630,  630,  630,  630,  630,  630,  630,  630,  630,  630,

      631,  631,  631,  631,  631,  631,  631,  631,  631,  631,
      631,  631,  631,  631,  631,  631,  631,  631,  631,  631,
      631,  631,  631,  631,  631,  631,  631,  631,  632,  632,
        0,  632,  632,  632,  632,  632,  632,  632,  632,  632,
      632,  632,  632,  632,  632,  632,  632,  632,  632,  632,
      632,  632,  632,  632,  632,  632,  633,  633,  633,  633,
      633,  633,  633,  633,  633,  633,  633,  633,  633,  633,
      633,  633,  633,  633,  633,  633,  633,  633,  633,  633,
      633,  633,  633,  633,  634,  634,    0,  634,  634,  634,
      634,  634,  634,  634,  634,  634,  634,  634,  634,  634,

      634,  634,  634,  634,  634,  634,  634,  634,  634,  634,
      634,  634,  635,  635,  635,    0,    0,  635,  635,    0,
      635,    0,    0,    0,  635,  635,  635,  635,  635,  635,
      635,  635,  636,  636,  636,    0,    0,    0,    0,  636,
      636,  636,  636,  636,  636,  636,  637,    0,  637,    0,
        0,    0,  637,  637,    0,  637,    0,    0,    0,    0,
      637,    0,    0,    0,    0,  637,  637,  637,  637,  637,
      637,  637,  638,    0,  638,    0,  638,    0,  638,    0,
        0,    0,    0,    0,    0,  638,  638,  638,  638,  638,
      638,  638,  639,  639,    0,  639,  639,  639,    0,    0,

        0,    0,  639,  639,  639,  639,  639,  639,  639,  640,
        0,    0,    0,  640,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  640,  640,  640,  640,  640,  640,  640,
      641,    0,    0,  641,    0,  641,    0,  641,    0,  641,
        0,    0,  641,  641,    0,    0,  641,  641,  641,  641,
      641,  641,  641,  642,  642,  642,  642,  642,  642,  642,
      642,  642,  642,  642,  642,  642,  642,  642,  642,  642,
      642,  642,  642,  642,  642,  642,  642,  642,  642,  642,
      642,  643,    0,    0,    0,    0,    0,  643,  643,    0,
        0,  643,  643,  643,    0,    0,    0,    0,  643,  643,

      643,  643,  643,  643,  643,  644,    0,    0,  644,  644,
      644,  644,  644,    0,  644,  644,    0,  644,  644,    0,
        0,  644,  644,  644,  644,  644,  644,  644,  644,  645,
      645,  645,  645,  645,    0,  645,  645,    0,  645,    0,
        0,    0,  645,  645,  645,  645,  645,  645,  645,  645,
      646,  646,  646,  646,  646,  646,  646,  646,  646,  646,
      646,  646,  646,  646,  646,  646,  646,  646,  646,  646,
      646,  646,  646,  646,  646,  646,  646,  646,  647,    0,
        0,    0,    0,    0,    0,    0,  647,    0,    0,    0,
        0,  647,    0,  647,  647,    0,    0,  647,  647,  648,

      648,  648,  648,  648,  648,  648,  648,  648,  648,  648,
      648,  648,  648,  648,  648,  648,  648,  648,  648,  648,
      648,  648,  648,  648,  648,  648,  648,  649,    0,  649,
      649,    0,    0,    0,    0,    0,  649,  649,  649,  649,
      649,  649,  649,  649,  650,  650,  650,  650,  650,  650,
      650,    0,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  650,  650,  650,  650,  650,  650,  650,  650,
      650,  650,  651,    0,    0,    0,  651,  651,  651,  651,
      651,  651,  651,  651,  651,  651,  651,  651,  651,  651,
      651,  651,  651,  651,  651,  651,  651,  651,  651,  651,

      652,  652,    0,  652,  652,    0,    0,    0,    0,    0,
      652,  652,  652,  652,  652,  652,  652,  652,  653,  653,
      653,  653,  653,  653,    0,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  654,  654,    0,    0,
        0,    0,    0,    0,  654,    0,    0,    0,    0,    0,
        0,    0,  654,    0,    0,  654,    0,  654,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  656,  656,    0,    0,

        0,    0,    0,    0,  656,    0,    0,    0,    0,    0,
        0,    0,  656,    0,    0,  656,    0,  656,  657,  657,
      657,  657,  657,  657,    0,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  658,  658,    0,    0,
        0,    0,    0,    0,  658,    0,    0,    0,    0,    0,
        0,    0,  658,    0,    0,  658,    0,  658,  659,    0,
        0,    0,    0,    0,  659,  659,    0,  659,  659,    0,
        0,    0,    0,  659,  659,  659,  659,  659,  659,  659,
      659,  659,  660,    0,    0,    0,    0,    0,  660,  660,

        0,  660,  660,    0,    0,    0,    0,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  662,  662,    0,    0,    0,    0,
        0,    0,  662,    0,    0,    0,    0,    0,    0,    0,
      662,    0,    0,  662,    0,  662,  663,  663,    0,    0,
        0,    0,    0,  663,  663,  663,  664,  664,    0,    0,
        0,    0,    0,  664,  664,  664,  664,  664,  664,  664,
      664,  665,  665,  665,  665,  665,  665,  665,  665,  665,

      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  666,
      666,  666,  666,  666,  666,  666,  666,  666,  666,  666,
      666,  666,  666,  666,  666,  666,  666,  666,  666,  666,
      666,  666,  666,  666,  666,  666,  666,  667,  667,  667,
      667,  667,  667,  667,  667,  667,  667,  667,  667,  667,
      667,  667,  667,  667,  667,  667,  667,  667,  667,  667,
      667,  667,  667,  667,  667,  668,  668,  668,  668,  668,
      668,  668,  668,  668,  668,  668,  668,  668,  668,  668,
      668,  668,  668,  668,  668,  668,  668,  668,  668,  668,

      668,  668,  668,  669,  669,    0,  669,  669,  669,  669,
      669,  669,  669,  669,  669,  669,  669,  669,  669,  669,
      669,  669,  669,  669,  669,  669,  669,  669,  669,  669,
      669,  670,  670,    0,  670,  670,  670,  670,  670,  670,
      670,  670,  670,  670,  670,  670,  670,  670,  670,  670,
      670,  670,  670,  670,  670,  670,  670,  670,  670,  671,
      671,    0,  671,  671,  671,  671,  671,  671,  671,  671,
      671,  671,  671,  671,  671,  671,  671,  671,  671,  671,
      671,  671,  671,  671,  671,  671,  671,  672,  672,    0,
      672,  672,  672,  672,  672,  672,  672,  672,  672,  672,

      672,  672,  672,  672,  672,  672,  672,  672,  672,  672,
      672,  672,  672,  672,  672,  673,  673,  673,    0,    0,
      673,  673,    0,  673,    0,    0,    0,  673,  673,  673,
      673,  673,  673,  673,  673,  674,    0,    0,  674,    0,
      674,    0,  674,    0,  674,    0,    0,  674,  674,    0,
        0,  674,  674,  674,  674,  674,  674,  674,  675,  675,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  675,  675,  675,  675,  675,
      675,  675,  676,    0,    0,  676,  676,  676,  676,  676,
        0,  676,  676,    0,  676,  676,    0,    0,  676,  676,

      676,  676,  676,  676,  676,  676,  677,  677,  677,  677,
      677,    0,  677,  677,    0,  677,    0,    0,    0,  677,
      677,  677,  677,  677,  677,  677,  677,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  678,  678,  678,  678,  678,
      678,  678,  678,  678,  678,  679,  679,    0,    0,    0,
        0,    0,  679,  679,  679,  680,  680,    0,    0,    0,
        0,    0,  680,  680,  680,  681,  681,    0,    0,    0,
        0,    0,  681,  681,  681,  682,  682,    0,    0,    0,
        0,    0,  682,  682,  682,  683,  683,    0,    0,    0,

        0,    0,  683,  683,  683,  684,  684,    0,    0,    0,
        0,    0,  684,  684,  684,  685,  685,    0,    0,    0,
        0,    0,  685,  685,  685,  686,  686,    0,    0,    0,
        0,    0,  686,  686,  686,  687,  687,  687,  687,  687,
      687,  687,  687,  687,  687,  687,  687,  687,  687,  687,
      687,  687,  687,  687,  687,  687,  687,  687,  687,  687,
      687,  687,  687,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,

      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600,  600,  600,  600,  600,  600,  600,  600,  600,  600,
      600
    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[117] =
    {   0,
0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
    1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 
    0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0,     };

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexer.l"
/* Lex file for rsyslog config format v2 (RainerScript).
* Please note: this file introduces the new config format, but maintains
* backward compatibility. In order to do so, the grammar is not 100% clean,
* but IMHO still sufficiently easy both to understand for programmers
* maitaining the code as well as users writing the config file. Users are,
* of course, encouraged to use new constructs only. But it needs to be noted
* that some of the legacy constructs (specifically the in-front-of-action
* PRI filter) are very hard to beat in ease of use, at least for simpler
* cases. So while we hope that cfsysline support can be dropped some time in
* the future, we will probably keep these useful constructs.
*
* Copyright 2011-2014 Rainer Gerhards and Adiscon GmbH.
*
* This file is part of the rsyslog runtime library.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
* 
*       http://www.apache.org/licenses/LICENSE-2.0
*       -or-
*       see COPYING.ASL20 in the source distribution
* 
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

#line 42 "lexer.l"
#include "parserif.h"
/*%option noyywrap nodefault case-insensitive */
/* avoid compiler warning: `yyunput' defined but not used */
#define YY_NO_INPUT 1

/* INOBJ is selected if we are inside an object (name/value pairs!) */

/* COMMENT is "the usual trick" to handle C-style comments */

/* INCL is in $IncludeConfig processing (skip to include file) */

/* LINENO: support for setting the linenumber */

/* INCALL: support for the call statement */

/* IN_PROCEDURE_CALL: support for the call statement */	

/* EXPR is a bit ugly, but we need it to support pre v6-syntax. The problem
* is that cfsysline statement start with $..., the same like variables in
* an expression. However, cfsysline statements can never appear inside an
* expression. So we create a specific expr mode, which is turned on after 
* we lexed a keyword that needs to be followed by an expression (using 
* knowledge from the upper layer...). In expr mode, we strictly do
* expression-based parsing. Expr mode is stopped when we reach a token
* that can not be part of an expression (currently only "then"). As I
* wrote this ugly, but the price needed to pay in order to remain
* compatible to the previous format.
*/
#line 77 "lexer.l"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <libestr.h>
#include "rainerscript.h"
#include "parserif.h"
#include "grammar.h"
static int preCommentState;	/* save for lex state before a comment */

struct bufstack {
	struct bufstack *prev;
	YY_BUFFER_STATE bs;
	int lineno;
	char *fn;
	es_str_t *estr;
} *currbs = NULL;

char *cnfcurrfn;			/* name of currently processed file */

int popfile(void);
int cnfSetLexFile(char *fname);

extern int yydebug;

/* somehow, I need these prototype even though the headers are 
 * included. I guess that's some autotools magic I don't understand...
 */
#if !defined(__FreeBSD__) && !defined(__NetBSD__) && !defined(__OpenBSD__) \
	&& !defined(__DragonflyBSD__) && !defined(_AIX)
int fileno(FILE *stream);
#endif


#line 1754 "lexer.c"

#define INITIAL 0
#define INOBJ 1
#define COMMENT 2
#define INCL 3
#define LINENO 4
#define INCALL 5
#define IN_PROCEDURE_CALL 6
#define EXPR 7

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * _in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * _out_str  );

yy_size_t yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int _line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

#ifndef YY_NO_UNPUT
    
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK /*LINTED*/break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    
	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	{
#line 114 "lexer.l"


 /* keywords */
#line 1984 "lexer.c"

	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 601 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 4164 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			yy_size_t yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					   
    yylineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 117 "lexer.l"
{ BEGIN EXPR; return IF; }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 118 "lexer.l"
{ BEGIN EXPR; return FOREACH; }
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 119 "lexer.l"
{ BEGIN IN_PROCEDURE_CALL; return RELOAD_LOOKUP_TABLE_PROCEDURE; }
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 120 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
case 5:
/* rule 5 can match eol */
YY_RULE_SETUP
#line 121 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 6:
/* rule 6 can match eol */
YY_RULE_SETUP
#line 126 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 131 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 132 "lexer.l"
{ BEGIN INITIAL; return yytext[0]; }
	YY_BREAK
case 9:
/* rule 9 can match eol */
YY_RULE_SETUP
#line 133 "lexer.l"
{  }
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 134 "lexer.l"
{ parser_errmsg("invalid character '%s' in expression "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 137 "lexer.l"
{ BEGIN EXPR; return yytext[0]; }
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 138 "lexer.l"
{ BEGIN INITIAL; return THEN; }
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 139 "lexer.l"
{ BEGIN INITIAL; return DO; }
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 140 "lexer.l"
{ BEGIN INITIAL; return ';'; }
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 141 "lexer.l"
{ return OR; }
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 142 "lexer.l"
{ return AND; }
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 143 "lexer.l"
{ return NOT; }
	YY_BREAK
case 18:
#line 145 "lexer.l"
case 19:
#line 146 "lexer.l"
case 20:
#line 147 "lexer.l"
case 21:
#line 148 "lexer.l"
case 22:
#line 149 "lexer.l"
case 23:
#line 150 "lexer.l"
case 24:
#line 151 "lexer.l"
case 25:
#line 152 "lexer.l"
case 26:
#line 153 "lexer.l"
case 27:
#line 154 "lexer.l"
case 28:
#line 155 "lexer.l"
case 29:
YY_RULE_SETUP
#line 155 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 156 "lexer.l"
{ return CMP_EQ; }
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 157 "lexer.l"
{ return CMP_LE; }
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 158 "lexer.l"
{ return CMP_GE; }
	YY_BREAK
case 33:
#line 160 "lexer.l"
case 34:
YY_RULE_SETUP
#line 160 "lexer.l"
{ return CMP_NE; }
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 161 "lexer.l"
{ return CMP_LT; }
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 162 "lexer.l"
{ return CMP_GT; }
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 163 "lexer.l"
{ return CMP_CONTAINS; }
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 164 "lexer.l"
{ return ITERATOR_ASSIGNMENT; }
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 165 "lexer.l"
{ return CMP_CONTAINSI; }
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 166 "lexer.l"
{ return CMP_STARTSWITH; }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 167 "lexer.l"
{ return CMP_STARTSWITHI; }
	YY_BREAK
case 42:
#line 169 "lexer.l"
case 43:
#line 170 "lexer.l"
case 44:
YY_RULE_SETUP
#line 170 "lexer.l"
{ yylval.n = strtoll(yytext, NULL, 0); return NUMBER; }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 171 "lexer.l"
{ yylval.s = strdup(yytext+1); return VAR; }
	YY_BREAK
case 46:
/* rule 46 can match eol */
YY_RULE_SETUP
#line 172 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 47:
/* rule 47 can match eol */
YY_RULE_SETUP
#line 177 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 48:
/* rule 48 can match eol */
YY_RULE_SETUP
#line 182 "lexer.l"

	YY_BREAK
case 49:
YY_RULE_SETUP
#line 183 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return FUNC; }
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 185 "lexer.l"
{ parser_errmsg("invalid character '%s' in expression "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 51:
/* rule 51 can match eol */
YY_RULE_SETUP
#line 188 "lexer.l"

	YY_BREAK
case 52:
YY_RULE_SETUP
#line 189 "lexer.l"
{ parser_errmsg("invalid character '%s' in 'call' statement"
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 192 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  BEGIN INITIAL;
				  return NAME; }
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 195 "lexer.l"
{ return '&'; }
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 196 "lexer.l"
{ return '{'; }
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 197 "lexer.l"
{ return '}'; }
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 198 "lexer.l"
{ return STOP; }
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 199 "lexer.l"
{ return ELSE; }
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 200 "lexer.l"
{ BEGIN INCALL; return CALL; }
	YY_BREAK
case 60:
YY_RULE_SETUP
#line 201 "lexer.l"
{ BEGIN EXPR; return CALL_INDIRECT; }
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 202 "lexer.l"
{ BEGIN EXPR; return SET; }
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 203 "lexer.l"
{ BEGIN EXPR; return RESET; }
	YY_BREAK
case 63:
YY_RULE_SETUP
#line 204 "lexer.l"
{ BEGIN EXPR; return UNSET; }
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 205 "lexer.l"
{ return CONTINUE; }
	YY_BREAK
/* line number support because the "preprocessor" combines lines and so needs
  * to tell us the real source line.
  */
case 65:
YY_RULE_SETUP
#line 209 "lexer.l"
{ BEGIN LINENO; }
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 210 "lexer.l"
{ yylineno = atoi(yytext) - 1; }
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 211 "lexer.l"
{ BEGIN INITIAL; }
	YY_BREAK
case 68:
/* rule 68 can match eol */
YY_RULE_SETUP
#line 212 "lexer.l"

	YY_BREAK
/* $IncludeConfig must be detected as part of CFSYSLINE, because this is
  * always the longest match :-(
  */
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 216 "lexer.l"

	YY_BREAK
case 70:
YY_RULE_SETUP
#line 217 "lexer.l"
{ if(cnfDoInclude(yytext) != 0)
					yyterminate();
				  BEGIN INITIAL; }
	YY_BREAK
case 71:
/* rule 71 can match eol */
YY_RULE_SETUP
#line 220 "lexer.l"
{ yylval.objType = CNFOBJ_MAINQ;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 72:
/* rule 72 can match eol */
YY_RULE_SETUP
#line 222 "lexer.l"
{ yylval.objType = CNFOBJ_TIMEZONE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
#line 224 "lexer.l"
{ yylval.objType = CNFOBJ_PARSER;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 74:
/* rule 74 can match eol */
YY_RULE_SETUP
#line 226 "lexer.l"
{ yylval.objType = CNFOBJ_GLOBAL;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 75:
/* rule 75 can match eol */
YY_RULE_SETUP
#line 228 "lexer.l"
{ yylval.objType = CNFOBJ_TPL;
				  BEGIN INOBJ; return BEGIN_TPL; }
	YY_BREAK
case 76:
/* rule 76 can match eol */
YY_RULE_SETUP
#line 230 "lexer.l"
{ yylval.objType = CNFOBJ_RULESET;
				  BEGIN INOBJ; return BEGIN_RULESET; }
	YY_BREAK
case 77:
/* rule 77 can match eol */
YY_RULE_SETUP
#line 232 "lexer.l"
{ yylval.objType = CNFOBJ_PROPERTY;
				  BEGIN INOBJ; return BEGIN_PROPERTY; }
	YY_BREAK
case 78:
/* rule 78 can match eol */
YY_RULE_SETUP
#line 234 "lexer.l"
{ yylval.objType = CNFOBJ_CONSTANT;
				  BEGIN INOBJ; return BEGIN_CONSTANT; }
	YY_BREAK
case 79:
/* rule 79 can match eol */
YY_RULE_SETUP
#line 236 "lexer.l"
{ yylval.objType = CNFOBJ_INPUT;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 80:
/* rule 80 can match eol */
YY_RULE_SETUP
#line 238 "lexer.l"
{ yylval.objType = CNFOBJ_MODULE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 81:
/* rule 81 can match eol */
YY_RULE_SETUP
#line 240 "lexer.l"
{ yylval.objType = CNFOBJ_LOOKUP_TABLE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 82:
/* rule 82 can match eol */
YY_RULE_SETUP
#line 242 "lexer.l"
{ yylval.objType = CNFOBJ_DYN_STATS;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 83:
/* rule 83 can match eol */
YY_RULE_SETUP
#line 244 "lexer.l"
{ BEGIN INOBJ; return BEGIN_ACTION; }
	YY_BREAK
case 84:
/* rule 84 can match eol */
YY_RULE_SETUP
#line 245 "lexer.l"
{
				  yylval.s = strdup(rmLeadingSpace(yytext));
				  dbgprintf("lexer: propfilt is '%s'\n", yylval.s);
				  return PROPFILT;
				  }
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 250 "lexer.l"
{ yylval.s = strdup(rmLeadingSpace(yytext)); return PRIFILT; }
	YY_BREAK
case 86:
#line 252 "lexer.l"
case 87:
#line 253 "lexer.l"
case 88:
/* rule 88 can match eol */
#line 254 "lexer.l"
case 89:
/* rule 89 can match eol */
#line 255 "lexer.l"
case 90:
/* rule 90 can match eol */
#line 256 "lexer.l"
case 91:
/* rule 91 can match eol */
#line 257 "lexer.l"
case 92:
/* rule 92 can match eol */
YY_RULE_SETUP
#line 257 "lexer.l"
{ yylval.s = yytext; return LEGACY_ACTION; }
	YY_BREAK
case 93:
YY_RULE_SETUP
#line 258 "lexer.l"
{ BEGIN INITIAL; return ENDOBJ; }
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 259 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return NAME; }
	YY_BREAK
case 95:
#line 262 "lexer.l"
case 96:
#line 263 "lexer.l"
case 97:
#line 264 "lexer.l"
case 98:
YY_RULE_SETUP
#line 264 "lexer.l"
{ return(yytext[0]); }
	YY_BREAK
case 99:
/* rule 99 can match eol */
YY_RULE_SETUP
#line 265 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
/*yylval.estr = es_newStrFromBuf(yytext+1, yyleng-2);
				  return VALUE; }*/
case 100:
YY_RULE_SETUP
#line 272 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 273 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 102:
YY_RULE_SETUP
#line 274 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 275 "lexer.l"
{ BEGIN preCommentState; }
	YY_BREAK
case 104:
/* rule 104 can match eol */
YY_RULE_SETUP
#line 276 "lexer.l"

	YY_BREAK
case 105:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 277 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 106:
/* rule 106 can match eol */
YY_RULE_SETUP
#line 278 "lexer.l"

	YY_BREAK
case 107:
YY_RULE_SETUP
#line 279 "lexer.l"
{ parser_errmsg("invalid character '%s' in object definition "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 108:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 282 "lexer.l"
{ /* see comment on $IncludeConfig above */
				  if(!strncasecmp(yytext, "$includeconfig ", 14)) {
					yyless((yy_size_t)14);
				  	BEGIN INCL;
				  } else if(!strncasecmp(yytext, "$ruleset ", 9)) {
					yylval.s = strdup(yytext);
					return LEGACY_RULESET;
				  } else {
					  cnfDoCfsysline(strdup(yytext)); 
				  }
				}
	YY_BREAK
case 109:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 293 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_TAG_SELECTOR; }
	YY_BREAK
case 110:
/* rule 110 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 294 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 111:
/* rule 111 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 295 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 112:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 296 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 113:
/* rule 113 can match eol */
YY_RULE_SETUP
#line 297 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 114:
/* rule 114 can match eol */
YY_RULE_SETUP
#line 298 "lexer.l"
/* drop whitespace */
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 299 "lexer.l"
{ parser_errmsg("invalid character '%s' "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(INOBJ):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(INCL):
case YY_STATE_EOF(LINENO):
case YY_STATE_EOF(INCALL):
case YY_STATE_EOF(IN_PROCEDURE_CALL):
case YY_STATE_EOF(EXPR):
#line 302 "lexer.l"
{ if(popfile() != 0) yyterminate(); }
	YY_BREAK
case 116:
YY_RULE_SETUP
#line 304 "lexer.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 2699 "lexer.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of user's declarations */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = (yytext_ptr);
	yy_size_t number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (yy_size_t) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			yy_size_t num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				yy_size_t new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((int) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		int new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	yy_state_type yy_current_state;
	char *yy_cp;
    
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 601 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	int yy_is_jam;
    	char *yy_cp = (yy_c_buf_p);

	YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 601 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 600);

		return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT

#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			yy_size_t offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');
	if ( YY_CURRENT_BUFFER_LVALUE->yy_at_bol )
		   
    yylineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = (yy_size_t)size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	yy_size_t num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		yy_size_t grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, yy_size_t  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	yy_size_t i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
			(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
yy_size_t yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param _line_number line number
 * 
 */
void yyset_lineno (int  _line_number )
{
    
    yylineno = _line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param _in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  _in_str )
{
        yyin = _in_str ;
}

void yyset_out (FILE *  _out_str )
{
        yyout = _out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  _bdebug )
{
        yy_flex_debug = _bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    /* We do not touch yylineno unless the option is enabled. */
    yylineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
		
	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
			return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
		
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
			free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 304 "lexer.l"


int
cnfParseBuffer(char *buf, unsigned lenBuf)
{
	struct bufstack *bs;
	int r = 0;
	yydebug = 1;
	BEGIN INITIAL;
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup("*buffer*");
	bs->bs = yy_scan_buffer(buf,lenBuf);
	bs->estr = NULL;
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
done:	return r;
}

/* set a new buffers. Returns 0 on success, 1 on error, 2 on file not exists.
 * note: in case of error, errno must be kept valid!
 */
int
cnfSetLexFile(char *fname)
{
	es_str_t *str = NULL;
	FILE *fp;
	int r = 0;
	struct bufstack *bs;

	/* check for invalid recursive include */
	for(bs = currbs ; bs != NULL ; bs = bs->prev) {
		if(!strcmp(fname, bs->fn)) {
			parser_errmsg("trying to include file '%s', "
				"which is already included - ignored", fname);
			r = 1;
			goto done;
		}
	}

	if(fname == NULL) {
		fp = stdin;
	} else {
		if((fp = fopen(fname, "r")) == NULL) {
			r = 2;
			goto done;
		}
	}
	readConfFile(fp, &str);
	if(fp != stdin)
		fclose(fp);
	
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup(fname == NULL ? "stdin" : fname);
	yy_size_t lll = es_strlen(str);
	//bs->bs = yy_scan_buffer((char*)es_getBufAddr(str),(yy_size_t) es_strlen(str));
	bs->bs = yy_scan_buffer((char*)es_getBufAddr(str),lll);
	bs->estr = str; /* needed so we can free it later */
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
	dbgprintf("config parser: pushed file %s on top of stack\n", fname);

done:
	if(r != 0) {
		if(str != NULL)
			es_deleteStr(str);
	}
	return r;
}


/* returns 0 on success, something else otherwise */
int
popfile(void)
{
	struct bufstack *bs = currbs;

	if(bs == NULL)
		return 1;
	
	/* delete current entry. But we must not free the file name if
	 * this is the top-level file, because then it may still be used
	 * in error messages for other processing steps.
	 * TODO: change this to another method which stores the file
	 * name inside the config objects. In the longer term, this is
	 * necessary, as otherwise we may provide wrong file name information
	 * at the end of include files as well. -- rgerhards, 2011-07-22
	 */
	dbgprintf("config parser: reached end of file %s\n", bs->fn);
	yy_delete_buffer(bs->bs);
	if(bs->prev != NULL)
		free(bs->fn);
	free(bs->estr);

	/* switch back to previous */
	currbs = bs->prev;
	free(bs);

	if(currbs == NULL) {
		dbgprintf("config parser: parsing completed\n");
		return 1; /* all processed */
	}
	
	yy_switch_to_buffer(currbs->bs);
	yylineno = currbs->lineno;
	cnfcurrfn = currbs->fn;
	dbgprintf("config parser: resume parsing of file %s at line %d\n",
		  cnfcurrfn, yylineno);
	return 0;
}

void
tellLexEndParsing(void)
{
	free(cnfcurrfn);
	cnfcurrfn= NULL;
}

